//
// Created by robin on 10/1/17.
//

#ifndef MIFARE_TOOLS_MAINWINDOW_H
#define MIFARE_TOOLS_MAINWINDOW_H


#include <QtWidgets/QMainWindow>
#include <libnfc_cpptools/LibNfcContext.h>

#include "ui_MainWindow.h"

class MainWindow : public QMainWindow
{
Q_OBJECT
public:
    explicit MainWindow(QWidget* parent = nullptr);
    ~MainWindow() override = default;

    bool initLibNfc();

    void refreshReaders();

    template<typename T> void showError(LibNfc::Utils::Result<T> result);

private:
    QScopedPointer<Ui_MainWindow> m_pUi;

    QSharedPointer<LibNfc::Core::LibNfcContext> m_pLibNfc;

    std::vector<std::shared_ptr<LibNfc::Core::NfcDevice>> m_devices;
};


#endif //MIFARE_TOOLS_MAINWINDOW_H
