//
// Created by robin on 7/22/16.
//

#ifndef LIBNFC_CPPTOOLS_FREEFARETAGBUSINESS_H
#define LIBNFC_CPPTOOLS_FREEFARETAGBUSINESS_H


#include <memory>
#include <libnfc_cpptools/FreeFareClassicSector.h>

namespace LibNfc
{
namespace FreeFare
{

class FreeFareTagInternal;

typedef std::vector<std::pair<std::string, std::string>> MappedKeys;

class FreeFareTag
{
public:
    enum FreeFareTagType {
        UNKNOWN,
        FELICA,
        MIFARE_MINI,
        MIFARE_CLASSIC_1K,
        MIFARE_CLASSIC_4K,
        MIFARE_DESFIRE,
        MIFARE_ULTRALIGHT,
        MIFARE_ULTRALIGHT_C
    };

    static std::string getTagTypeString(FreeFareTagType type);

    explicit FreeFareTag(std::shared_ptr<FreeFareTagInternal> tag);
    ~FreeFareTag() = default;

    const std::string& getUid() const;

    FreeFareTagType getType() const;

    std::shared_ptr<FreeFareTagInternal> getTag() const;

protected:
    std::shared_ptr<FreeFareTagInternal> _tag;
};

}; // FreeFare
}; // LibNfc

#endif //LIBNFC_CPPTOOLS_FREEFARETAGBUSINESS_H
