//
// Created by robin on 7/22/16.
//

#ifndef LIBNFC_CPPTOOLS_LIBNFCBUSINESS_H
#define LIBNFC_CPPTOOLS_LIBNFCBUSINESS_H


#include <libnfc_cpptools/Result.h>
#include <libnfc_cpptools/NfcDevice.h>

namespace LibNfc
{
namespace Core
{

class LibNfcContextInternal;

class LibNfcContext
{
public:
    LibNfcContext();
    virtual ~LibNfcContext();

    LibNfc::Utils::ResultBool init();

    void clean();

    bool isInitialized() const;

    LibNfc::Utils::Result<std::vector<std::shared_ptr<NfcDevice>>> getDevices() const;

    static std::string getLibNfcVersion();

    static std::string getLibNfcCppToolsVersion();

protected:
    std::shared_ptr<LibNfcContextInternal> _libNfc;
};

}; // Core
}; // LibNfc

#endif //LIBNFC_CPPTOOLS_LIBNFCBUSINESS_H
