//
// Created by robin on 7/22/16.
//

#include "libnfc_cpptools/FreeFareTag.h"
#include "libnfc_cpptools/StringUtils.h"
#include "FreeFareTagInternal.h"

namespace LibNfc
{
namespace FreeFare
{

std::string FreeFareTag::getTagTypeString(FreeFareTag::FreeFareTagType type)
{
    if (type == FreeFareTagType::FELICA)
    {
        return "FELICA";
    }
    if (type == FreeFareTagType::MIFARE_MINI)
    {
        return "MIFARE_MINI";
    }
    if (type == FreeFareTagType::MIFARE_CLASSIC_1K)
    {
        return "MIFARE_CLASSIC_1K";
    }
    if (type == FreeFareTagType::MIFARE_CLASSIC_4K)
    {
        return "MIFARE_CLASSIC_4K";
    }
    if (type == FreeFareTagType::MIFARE_DESFIRE)
    {
        return "MIFARE_DESFIRE";
    }
    if (type == FreeFareTagType::MIFARE_ULTRALIGHT)
    {
        return "MIFARE_ULTRALIGHT";
    }
    if (type == FreeFareTagType::MIFARE_ULTRALIGHT_C)
    {
        return "MIFARE_ULTRALIGHT_C";
    }
    return "UNKNOWN";
}

FreeFareTag::FreeFareTag(std::shared_ptr<FreeFareTagInternal> tag)
    : _tag(tag)
{
}


const std::string &FreeFareTag::getUid() const
{
    return _tag->getUid();
}

FreeFareTag::FreeFareTagType FreeFareTag::getType() const
{
    auto type = _tag->getType();
    if (type == freefare_tag_type::FELICA)
    {
        return FreeFareTagType::FELICA;
    }
    if (type == freefare_tag_type::MIFARE_MINI)
    {
        return FreeFareTagType::MIFARE_MINI;
    }
    if (type == freefare_tag_type::MIFARE_CLASSIC_1K)
    {
        return FreeFareTagType::MIFARE_CLASSIC_1K;
    }
    if (type == freefare_tag_type::MIFARE_CLASSIC_4K)
    {
        return FreeFareTagType::MIFARE_CLASSIC_4K;
    }
    if (type == freefare_tag_type::MIFARE_DESFIRE)
    {
        return FreeFareTagType::MIFARE_DESFIRE;
    }
    if (type == freefare_tag_type::MIFARE_ULTRALIGHT)
    {
        return FreeFareTagType::MIFARE_ULTRALIGHT;
    }
    if (type == freefare_tag_type::MIFARE_ULTRALIGHT_C)
    {
        return FreeFareTagType::MIFARE_ULTRALIGHT_C;
    }
    return FreeFareTagType::UNKNOWN;
}

std::shared_ptr<FreeFareTagInternal> FreeFareTag::getTag() const
{
    return _tag;
}

}; // FreeFare
}; // LibNfc
