//
// Created by robin on 6/19/16.
//

#include <sstream>
#include <map>
#include "FreeFareTagInternal.h"

namespace LibNfc
{
namespace FreeFare
{

FreeFareTagInternal::FreeFareTagInternal(FreefareTag tag)
    : _tag(tag)
    , _type(freefare_get_tag_type(tag))
    , _uid(freefare_get_tag_uid(tag))
{
}

FreeFareTagInternal::~FreeFareTagInternal()
{
    freefare_free_tag(_tag);
}

const freefare_tag *FreeFareTagInternal::getTag() const
{
    return _tag;
}

freefare_tag_type FreeFareTagInternal::getType() const
{
    return _type;
}

const std::string &FreeFareTagInternal::getUid() const
{
    return _uid;
}

}; // FreeFare
}; // LibNfc
