//
// Created by robin on 6/19/16.
//

#ifndef LIBNFC_CPPTOOLS_LIBNFC_H
#define LIBNFC_CPPTOOLS_LIBNFC_H

#include <memory>
#include <nfc/nfc.h>
#include "NfcDeviceInternal.h"
#include "libnfc_cpptools/Result.h"

namespace LibNfc
{
namespace Core
{

class NfcDeviceInternal;

class LibNfcContextInternal
{
public:
    LibNfcContextInternal();
    virtual ~LibNfcContextInternal();

    LibNfc::Utils::ResultBool init();

    void clean();

    LibNfc::Utils::Result<std::vector<std::shared_ptr<NfcDeviceInternal>>> getDevices() const;

    static std::string getVersion();

    nfc_context* getContext() const;

protected:
    nfc_context* _context;
};

}; // Core
}; // LibNfc

#endif //LIBNFC_CPPTOOLS_LIBNFC_H
